Package com.enonic.xp.data

## Class PropertySet

- java.lang.Object
- - com.enonic.xp.data.PropertySet

-     @PublicApi
      public final class PropertySet
      extends Object

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `PropertySet()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Property` | `addBinaryReference​(String name, BinaryReference value)` |
    `Property[]` | `addBinaryReferences​(String name, BinaryReference... values)` |
    `Property` | `addBoolean​(String name, Boolean value)` |
    `Property[]` | `addBooleans​(String name, Boolean... values)` |
    `Property` | `addDouble​(String name, Double value)` |
    `Property[]` | `addDoubles​(String name, Double... values)` |
    `Property` | `addEnum​(String name, Enum value)` |
    `Property` | `addGeoPoint​(String name, GeoPoint value)` |
    `Property[]` | `addGeoPoints​(String name, GeoPoint... values)` |
    `Property` | `addInstant​(String name, Instant value)` |
    `Property[]` | `addInstants​(String name, Instant... values)` |
    `Property` | `addLink​(String name, Link value)` |
    `Property[]` | `addLinks​(String name, Link... values)` |
    `Property` | `addLocalDate​(String name, LocalDate value)` |
    `Property[]` | `addLocalDates​(String name, LocalDate... values)` |
    `Property` | `addLocalDateTime​(String name, LocalDateTime value)` |
    `Property[]` | `addLocalDateTimes​(String name, LocalDateTime... values)` |
    `Property` | `addLocalTime​(String name, LocalTime value)` |
    `Property[]` | `addLocalTimes​(String name, LocalTime... values)` |
    `Property` | `addLong​(String name, Long value)` |
    `Property[]` | `addLongs​(String name, Long... values)` |
    `Property` | `addProperty​(String name, Value value)` |
    `Property` | `addReference​(String name, Reference value)` |
    `Property[]` | `addReferences​(String name, Reference... values)` |
    `PropertySet` | `addSet​(String name)` |
    `Property` | `addSet​(String name, PropertySet value)` |
    `Property[]` | `addSets​(String name, PropertySet... values)` |
    `Property` | `addString​(String name, String value)` |
    `Property[]` | `addStrings​(String name, String... values)` |
    `Property[]` | `addStrings​(String name, Collection<String> values)` |
    `Property` | `addXml​(String name, String value)` |
    `Property[]` | `addXmls​(String name, String... values)` |
    `PropertySet` | `copy​(PropertyTree tree)` |
    `int` | `countAncestors()` | Deprecated.
    `int` | `countProperties​(String name)` |
    `PropertySet` | `detach()` |
    `void` | `ensureProperty​(String name, ValueType valueType)` | WARNING: This method may be removed at any time.
    `boolean` | `equals​(Object o)` |
    `BinaryReference` | `getBinaryReference​(PropertyPath path)` |
    `BinaryReference` | `getBinaryReference​(String path)` |
    `BinaryReference` | `getBinaryReference​(String name, int index)` |
    `Iterable<BinaryReference>` | `getBinaryReferences​(String name)` |
    `Boolean` | `getBoolean​(PropertyPath path)` |
    `Boolean` | `getBoolean​(String path)` |
    `Boolean` | `getBoolean​(String name, int index)` |
    `Iterable<Boolean>` | `getBooleans​(String name)` |
    `Double` | `getDouble​(PropertyPath path)` |
    `Double` | `getDouble​(String path)` |
    `Double` | `getDouble​(String name, int index)` |
    `Iterable<Double>` | `getDoubles​(String name)` |
    `<T extends Enum<T>> T` | `getEnum​(PropertyPath path, Class<T> enumClass)` |
    `<T extends Enum<T>> T` | `getEnum​(String name, int index, Class<T> enumClass)` |
    `<T extends Enum<T>> T` | `getEnum​(String path, Class<T> enumClass)` |
    `GeoPoint` | `getGeoPoint​(PropertyPath path)` |
    `GeoPoint` | `getGeoPoint​(String path)` |
    `GeoPoint` | `getGeoPoint​(String name, int index)` |
    `Iterable<GeoPoint>` | `getGeoPoints​(String name)` |
    `Instant` | `getInstant​(PropertyPath path)` |
    `Instant` | `getInstant​(String path)` |
    `Instant` | `getInstant​(String name, int index)` |
    `Iterable<Instant>` | `getInstants​(String name)` |
    `Link` | `getLink​(PropertyPath path)` |
    `Link` | `getLink​(String path)` |
    `Link` | `getLink​(String name, int index)` |
    `Iterable<Link>` | `getLinks​(String name)` |
    `LocalDate` | `getLocalDate​(PropertyPath path)` |
    `LocalDate` | `getLocalDate​(String path)` |
    `LocalDate` | `getLocalDate​(String name, int index)` |
    `Iterable<LocalDate>` | `getLocalDates​(String name)` |
    `LocalDateTime` | `getLocalDateTime​(PropertyPath path)` |
    `LocalDateTime` | `getLocalDateTime​(String path)` |
    `LocalDateTime` | `getLocalDateTime​(String name, int index)` |
    `Iterable<LocalDateTime>` | `getLocalDateTimes​(String name)` |
    `LocalTime` | `getLocalTime​(PropertyPath path)` |
    `LocalTime` | `getLocalTime​(String path)` |
    `LocalTime` | `getLocalTime​(String name, int index)` |
    `Iterable<LocalTime>` | `getLocalTimes​(String name)` |
    `Long` | `getLong​(PropertyPath path)` |
    `Long` | `getLong​(String path)` |
    `Long` | `getLong​(String name, int index)` |
    `Iterable<Long>` | `getLongs​(String name)` |
    `Iterable<Property>` | `getProperties()` |
    `ImmutableList<Property>` | `getProperties​(ValueType valueType)` |
    `ImmutableList<Property>` | `getProperties​(String name)` |
    `Property` | `getProperty()` |
    `Property` | `getProperty​(PropertyPath path)` |
    `Property` | `getProperty​(String path)` |
    `Property` | `getProperty​(String name, int index)` |
    `Collection<PropertyArray>` | `getPropertyArrays()` |
    `String[]` | `getPropertyNames()` |
    `PropertySet` | `getPropertySet​(PropertyPath path)` |
    `PropertySet` | `getPropertySet​(String path)` |
    `int` | `getPropertySize()` |
    `Reference` | `getReference​(PropertyPath path)` |
    `Reference` | `getReference​(String path)` |
    `Reference` | `getReference​(String name, int index)` |
    `Iterable<Reference>` | `getReferences​(String name)` |
    `PropertySet` | `getSet​(PropertyPath path)` |
    `PropertySet` | `getSet​(String path)` |
    `PropertySet` | `getSet​(String name, int index)` |
    `Iterable<PropertySet>` | `getSets​(String name)` |
    `String` | `getString​(PropertyPath path)` |
    `String` | `getString​(String path)` |
    `String` | `getString​(String name, int index)` |
    `Iterable<String>` | `getStrings​(String name)` |
    `PropertyTree` | `getTree()` |
    `Value` | `getValue​(PropertyPath path)` |
    `Value` | `getValue​(String path)` |
    `Value` | `getValue​(String name, int index)` |
    `Iterable<Value>` | `getValues​(String name)` |
    `int` | `hashCode()` |
    `boolean` | `hasProperty​(PropertyPath path)` |
    `boolean` | `hasProperty​(String path)` |
    `boolean` | `hasProperty​(String name, int index)` |
    `PropertySet` | `ifNotNull()` |
    `boolean` | `isNotNull​(PropertyPath path)` |
    `boolean` | `isNotNull​(String path)` |
    `boolean` | `isNull​(PropertyPath path)` |
    `boolean` | `isNull​(String path)` |
    `PropertySet` | `newSet()` |
    `void` | `removeProperties​(String name)` |
    `void` | `removeProperty​(PropertyPath path)` |
    `void` | `removeProperty​(String path)` |
    `Property` | `setBinaryReference​(PropertyPath path, BinaryReference value)` |
    `Property` | `setBinaryReference​(String name, int index, BinaryReference value)` |
    `Property` | `setBinaryReference​(String path, BinaryReference value)` |
    `Property` | `setBoolean​(PropertyPath path, Boolean value)` |
    `Property` | `setBoolean​(String name, int index, Boolean value)` |
    `Property` | `setBoolean​(String path, Boolean value)` |
    `Property` | `setDouble​(PropertyPath path, Double value)` |
    `Property` | `setDouble​(String name, int index, Double value)` |
    `Property` | `setDouble​(String path, Double value)` |
    `Property` | `setEnum​(PropertyPath path, Enum value)` |
    `Property` | `setEnum​(String name, int index, Enum value)` |
    `Property` | `setEnum​(String path, Enum value)` |
    `Property` | `setGeoPoint​(PropertyPath path, GeoPoint value)` |
    `Property` | `setGeoPoint​(String name, int index, GeoPoint value)` |
    `Property` | `setGeoPoint​(String path, GeoPoint value)` |
    `Property` | `setInstant​(PropertyPath path, Instant value)` |
    `Property` | `setInstant​(String name, int index, Instant value)` |
    `Property` | `setInstant​(String path, Instant value)` |
    `Property` | `setLink​(PropertyPath path, Link value)` |
    `Property` | `setLink​(String name, int index, Link value)` |
    `Property` | `setLink​(String path, Link value)` |
    `Property` | `setLocalDate​(PropertyPath path, LocalDate value)` |
    `Property` | `setLocalDate​(String name, int index, LocalDate value)` |
    `Property` | `setLocalDate​(String path, LocalDate value)` |
    `Property` | `setLocalDateTime​(PropertyPath path, LocalDateTime value)` |
    `Property` | `setLocalDateTime​(String name, int index, LocalDateTime value)` |
    `Property` | `setLocalDateTime​(String path, LocalDateTime value)` |
    `Property` | `setLocalTime​(PropertyPath path, LocalTime value)` |
    `Property` | `setLocalTime​(String name, int index, LocalTime value)` |
    `Property` | `setLocalTime​(String path, LocalTime value)` |
    `Property` | `setLong​(PropertyPath path, Long value)` |
    `Property` | `setLong​(String name, int index, Long value)` |
    `Property` | `setLong​(String path, Long value)` |
    `Property` | `setProperty​(PropertyPath path, Value value)` |
    `Property` | `setProperty​(String name, int index, Value value)` |
    `Property` | `setProperty​(String path, Value value)` |
    `Property` | `setReference​(PropertyPath path, Reference value)` |
    `Property` | `setReference​(String name, int index, Reference value)` |
    `Property` | `setReference​(String path, Reference value)` |
    `Property` | `setSet​(PropertyPath path, PropertySet value)` |
    `Property` | `setSet​(String name, int index, PropertySet value)` |
    `Property` | `setSet​(String path, PropertySet value)` |
    `Property` | `setString​(PropertyPath path, String value)` |
    `Property` | `setString​(String name, int index, String value)` |
    `Property` | `setString​(String path, String value)` |
    `void` | `setValues​(PropertyPath path, Iterable<Value> values)` |
    `void` | `setValues​(String path, Iterable<Value> values)` |
    `Property` | `setXml​(PropertyPath path, String value)` |
    `Property` | `setXml​(String name, int index, String value)` |
    `Property` | `setXml​(String path, String value)` |
    `Map<String,​Object>` | `toMap()` |
    `String` | `toString()` |
    `PropertyTree` | `toTree()` |

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### PropertySet

          public PropertySet()

  - ### Method Detail

    - #### getTree

          public PropertyTree getTree()

    - #### getProperty

          public Property getProperty()

    - #### toMap

          public Map<String,​Object> toMap()

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `Object`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### copy

          public PropertySet copy​(PropertyTree tree)

    - #### toTree

          public PropertyTree toTree()

    - #### countAncestors

          @Deprecated
          public int countAncestors()

      Deprecated.

    - #### ifNotNull

          public PropertySet ifNotNull()

    - #### newSet

          public PropertySet newSet()

    - #### detach

          public PropertySet detach()

    - #### countProperties

          public int countProperties​(String name)

    - #### addProperty

          public Property addProperty​(String name,
                                      Value value)

    - #### setProperty

          public Property setProperty​(String path,
                                      Value value)

    - #### setProperty

          public Property setProperty​(PropertyPath path,
                                      Value value)

    - #### ensureProperty

          public void ensureProperty​(String name,
                                     ValueType valueType)

      WARNING: This method may be removed at any time. It is not recommended to use it in new code. This method is only used to simulate the behavior of PropertySet Serialisation. See `PropertyArrayJson.fromJson(com.enonic.xp.data.PropertySet)`
      Ensures that the property with the given name has type of valueType given. If the property does not exist, empty property (without values) will be created. If the property with values exists and is not a type of valueType given, an exception will be thrown. Difference with setProperty is that this method does not set the property value.
      Parameters:
        `name` - property name
        `valueType` - expected value type

    - #### setProperty

          public Property setProperty​(String name,
                                      int index,
                                      Value value)

    - #### setValues

          public void setValues​(String path,
                                Iterable<Value> values)

    - #### setValues

          public void setValues​(PropertyPath path,
                                Iterable<Value> values)

    - #### removeProperty

          public void removeProperty​(String path)

    - #### removeProperty

          public void removeProperty​(PropertyPath path)

    - #### removeProperties

          public void removeProperties​(String name)

    - #### hasProperty

          public boolean hasProperty​(String path)

    - #### hasProperty

          public boolean hasProperty​(PropertyPath path)

    - #### hasProperty

          public boolean hasProperty​(String name,
                                     int index)

    - #### getProperty

          public Property getProperty​(String path)

    - #### getProperty

          public Property getProperty​(PropertyPath path)

    - #### getProperty

          public Property getProperty​(String name,
                                      int index)

    - #### isNull

          public boolean isNull​(String path)

    - #### isNull

          public boolean isNull​(PropertyPath path)

    - #### isNotNull

          public boolean isNotNull​(String path)

    - #### isNotNull

          public boolean isNotNull​(PropertyPath path)

    - #### getPropertyNames

          public String[] getPropertyNames()

    - #### getProperties

          public ImmutableList<Property> getProperties​(String name)

    - #### getProperties

          public Iterable<Property> getProperties()

    - #### getProperties

          public ImmutableList<Property> getProperties​(ValueType valueType)

    - #### getPropertySize

          public int getPropertySize()

    - #### getPropertyArrays

          public Collection<PropertyArray> getPropertyArrays()

    - #### getValue

          public Value getValue​(String name,
                                int index)

    - #### getValue

          public Value getValue​(PropertyPath path)

    - #### getValue

          public Value getValue​(String path)

    - #### getValues

          public Iterable<Value> getValues​(String name)

    - #### getPropertySet

          public PropertySet getPropertySet​(PropertyPath path)

    - #### getPropertySet

          public PropertySet getPropertySet​(String path)

    - #### setSet

          public Property setSet​(String path,
                                 PropertySet value)

    - #### setSet

          public Property setSet​(PropertyPath path,
                                 PropertySet value)

    - #### setSet

          public Property setSet​(String name,
                                 int index,
                                 PropertySet value)

    - #### addSet

          public Property addSet​(String name,
                                 PropertySet value)

    - #### addSets

          public Property[] addSets​(String name,
                                    PropertySet... values)

    - #### addSet

          public PropertySet addSet​(String name)

    - #### setString

          public Property setString​(String path,
                                    String value)

    - #### setString

          public Property setString​(PropertyPath path,
                                    String value)

    - #### setString

          public Property setString​(String name,
                                    int index,
                                    String value)

    - #### addString

          public Property addString​(String name,
                                    String value)

    - #### addStrings

          public Property[] addStrings​(String name,
                                       String... values)

    - #### addStrings

          public Property[] addStrings​(String name,
                                       Collection<String> values)

    - #### setXml

          public Property setXml​(String path,
                                 String value)

    - #### setXml

          public Property setXml​(PropertyPath path,
                                 String value)

    - #### setXml

          public Property setXml​(String name,
                                 int index,
                                 String value)

    - #### addXml

          public Property addXml​(String name,
                                 String value)

    - #### addXmls

          public Property[] addXmls​(String name,
                                    String... values)

    - #### setBoolean

          public Property setBoolean​(String path,
                                     Boolean value)

    - #### setBoolean

          public Property setBoolean​(PropertyPath path,
                                     Boolean value)

    - #### setBoolean

          public Property setBoolean​(String name,
                                     int index,
                                     Boolean value)

    - #### addBoolean

          public Property addBoolean​(String name,
                                     Boolean value)

    - #### addBooleans

          public Property[] addBooleans​(String name,
                                        Boolean... values)

    - #### setLong

          public Property setLong​(String path,
                                  Long value)

    - #### setLong

          public Property setLong​(PropertyPath path,
                                  Long value)

    - #### setLong

          public Property setLong​(String name,
                                  int index,
                                  Long value)

    - #### addLong

          public Property addLong​(String name,
                                  Long value)

    - #### addLongs

          public Property[] addLongs​(String name,
                                     Long... values)

    - #### setLocalDate

          public Property setLocalDate​(String path,
                                       LocalDate value)

    - #### setLocalDate

          public Property setLocalDate​(PropertyPath path,
                                       LocalDate value)

    - #### setLocalDate

          public Property setLocalDate​(String name,
                                       int index,
                                       LocalDate value)

    - #### addLocalDate

          public Property addLocalDate​(String name,
                                       LocalDate value)

    - #### addLocalDates

          public Property[] addLocalDates​(String name,
                                          LocalDate... values)

    - #### setLocalDateTime

          public Property setLocalDateTime​(String path,
                                           LocalDateTime value)

    - #### setLocalDateTime

          public Property setLocalDateTime​(PropertyPath path,
                                           LocalDateTime value)

    - #### setLocalDateTime

          public Property setLocalDateTime​(String name,
                                           int index,
                                           LocalDateTime value)

    - #### addLocalDateTime

          public Property addLocalDateTime​(String name,
                                           LocalDateTime value)

    - #### addLocalDateTimes

          public Property[] addLocalDateTimes​(String name,
                                              LocalDateTime... values)

    - #### setLocalTime

          public Property setLocalTime​(String path,
                                       LocalTime value)

    - #### setLocalTime

          public Property setLocalTime​(PropertyPath path,
                                       LocalTime value)

    - #### setLocalTime

          public Property setLocalTime​(String name,
                                       int index,
                                       LocalTime value)

    - #### addLocalTime

          public Property addLocalTime​(String name,
                                       LocalTime value)

    - #### addLocalTimes

          public Property[] addLocalTimes​(String name,
                                          LocalTime... values)

    - #### setInstant

          public Property setInstant​(String path,
                                     Instant value)

    - #### setInstant

          public Property setInstant​(PropertyPath path,
                                     Instant value)

    - #### setInstant

          public Property setInstant​(String name,
                                     int index,
                                     Instant value)

    - #### addInstant

          public Property addInstant​(String name,
                                     Instant value)

    - #### addInstants

          public Property[] addInstants​(String name,
                                        Instant... values)

    - #### setDouble

          public Property setDouble​(String path,
                                    Double value)

    - #### setDouble

          public Property setDouble​(PropertyPath path,
                                    Double value)

    - #### setDouble

          public Property setDouble​(String name,
                                    int index,
                                    Double value)

    - #### addDouble

          public Property addDouble​(String name,
                                    Double value)

    - #### addDoubles

          public Property[] addDoubles​(String name,
                                       Double... values)

    - #### setGeoPoint

          public Property setGeoPoint​(String path,
                                      GeoPoint value)

    - #### setGeoPoint

          public Property setGeoPoint​(PropertyPath path,
                                      GeoPoint value)

    - #### setGeoPoint

          public Property setGeoPoint​(String name,
                                      int index,
                                      GeoPoint value)

    - #### addGeoPoint

          public Property addGeoPoint​(String name,
                                      GeoPoint value)

    - #### addGeoPoints

          public Property[] addGeoPoints​(String name,
                                         GeoPoint... values)

    - #### setReference

          public Property setReference​(String path,
                                       Reference value)

    - #### setReference

          public Property setReference​(PropertyPath path,
                                       Reference value)

    - #### setReference

          public Property setReference​(String name,
                                       int index,
                                       Reference value)

    - #### addReference

          public Property addReference​(String name,
                                       Reference value)

    - #### addReferences

          public Property[] addReferences​(String name,
                                          Reference... values)

    - #### setBinaryReference

          public Property setBinaryReference​(String path,
                                             BinaryReference value)

    - #### setBinaryReference

          public Property setBinaryReference​(PropertyPath path,
                                             BinaryReference value)

    - #### setBinaryReference

          public Property setBinaryReference​(String name,
                                             int index,
                                             BinaryReference value)

    - #### addBinaryReference

          public Property addBinaryReference​(String name,
                                             BinaryReference value)

    - #### addBinaryReferences

          public Property[] addBinaryReferences​(String name,
                                                BinaryReference... values)

    - #### setLink

          public Property setLink​(String path,
                                  Link value)

    - #### setLink

          public Property setLink​(PropertyPath path,
                                  Link value)

    - #### setLink

          public Property setLink​(String name,
                                  int index,
                                  Link value)

    - #### addLink

          public Property addLink​(String name,
                                  Link value)

    - #### addLinks

          public Property[] addLinks​(String name,
                                     Link... values)

    - #### getSet

          public PropertySet getSet​(String name,
                                    int index)

    - #### getSet

          public PropertySet getSet​(PropertyPath path)

    - #### getSet

          public PropertySet getSet​(String path)

    - #### getSets

          public Iterable<PropertySet> getSets​(String name)

    - #### getString

          public String getString​(String name,
                                  int index)

    - #### getString

          public String getString​(PropertyPath path)

    - #### getString

          public String getString​(String path)

    - #### getStrings

          public Iterable<String> getStrings​(String name)

    - #### getBoolean

          public Boolean getBoolean​(String name,
                                    int index)

    - #### getBoolean

          public Boolean getBoolean​(PropertyPath path)

    - #### getBoolean

          public Boolean getBoolean​(String path)

    - #### getBooleans

          public Iterable<Boolean> getBooleans​(String name)

    - #### getLong

          public Long getLong​(String name,
                              int index)

    - #### getLong

          public Long getLong​(PropertyPath path)

    - #### getLong

          public Long getLong​(String path)

    - #### getLongs

          public Iterable<Long> getLongs​(String name)

    - #### getDouble

          public Double getDouble​(String name,
                                  int index)

    - #### getDouble

          public Double getDouble​(PropertyPath path)

    - #### getDouble

          public Double getDouble​(String path)

    - #### getDoubles

          public Iterable<Double> getDoubles​(String name)

    - #### getGeoPoint

          public GeoPoint getGeoPoint​(String name,
                                      int index)

    - #### getGeoPoint

          public GeoPoint getGeoPoint​(PropertyPath path)

    - #### getGeoPoint

          public GeoPoint getGeoPoint​(String path)

    - #### getGeoPoints

          public Iterable<GeoPoint> getGeoPoints​(String name)

    - #### getReference

          public Reference getReference​(String name,
                                        int index)

    - #### getReference

          public Reference getReference​(PropertyPath path)

    - #### getReference

          public Reference getReference​(String path)

    - #### getReferences

          public Iterable<Reference> getReferences​(String name)

    - #### getBinaryReference

          public BinaryReference getBinaryReference​(String name,
                                                    int index)

    - #### getBinaryReference

          public BinaryReference getBinaryReference​(PropertyPath path)

    - #### getBinaryReference

          public BinaryReference getBinaryReference​(String path)

    - #### getBinaryReferences

          public Iterable<BinaryReference> getBinaryReferences​(String name)

    - #### getLink

          public Link getLink​(String name,
                              int index)

    - #### getLink

          public Link getLink​(PropertyPath path)

    - #### getLink

          public Link getLink​(String path)

    - #### getLinks

          public Iterable<Link> getLinks​(String name)

    - #### getLocalDate

          public LocalDate getLocalDate​(String name,
                                        int index)

    - #### getLocalDate

          public LocalDate getLocalDate​(PropertyPath path)

    - #### getLocalDate

          public LocalDate getLocalDate​(String path)

    - #### getLocalDates

          public Iterable<LocalDate> getLocalDates​(String name)

    - #### getLocalDateTime

          public LocalDateTime getLocalDateTime​(String name,
                                                int index)

    - #### getLocalDateTime

          public LocalDateTime getLocalDateTime​(PropertyPath path)

    - #### getLocalDateTime

          public LocalDateTime getLocalDateTime​(String path)

    - #### getLocalDateTimes

          public Iterable<LocalDateTime> getLocalDateTimes​(String name)

    - #### getLocalTime

          public LocalTime getLocalTime​(String name,
                                        int index)

    - #### getLocalTime

          public LocalTime getLocalTime​(PropertyPath path)

    - #### getLocalTime

          public LocalTime getLocalTime​(String path)

    - #### getLocalTimes

          public Iterable<LocalTime> getLocalTimes​(String name)

    - #### getInstant

          public Instant getInstant​(String name,
                                    int index)

    - #### getInstant

          public Instant getInstant​(PropertyPath path)

    - #### getInstant

          public Instant getInstant​(String path)

    - #### getInstants

          public Iterable<Instant> getInstants​(String name)

    - #### getEnum

          public <T extends Enum<T>> T getEnum​(String name,
                                               int index,
                                               Class<T> enumClass)

    - #### getEnum

          public <T extends Enum<T>> T getEnum​(PropertyPath path,
                                               Class<T> enumClass)

    - #### getEnum

          public <T extends Enum<T>> T getEnum​(String path,
                                               Class<T> enumClass)

    - #### setEnum

          public Property setEnum​(String path,
                                  Enum value)

    - #### setEnum

          public Property setEnum​(PropertyPath path,
                                  Enum value)

    - #### setEnum

          public Property setEnum​(String name,
                                  int index,
                                  Enum value)

    - #### addEnum

          public Property addEnum​(String name,
                                  Enum value)